// ----------------------------------------------------
//		Copyright (C) 2014 by Focus Learning Corporation
//		All rights reserved.
//
//		This software is the confidential and proprietary information
//		of Focus Learning Corporation ("Confidential Information").
// ----------------------------------------------------

var grid, loadingIndicator;

// ----------------------------------------------------

$(document).ready(function () {
    //    ManualScoringInit();
    var data = [
            { "learnerId": 1, "lastName": "Brando", "firstName": "Marlon", "dateCompleted": "10/24/1989", "score": 79 },
            { "learnerId": 2, "lastName": "Damon", "firstName": "Matt", "dateCompleted": "12 / 24 / 1998", "score": 88 },
            { "learnerId": 3, "lastName": "Rockwell", "firstName": "Sam", "dateCompleted": "03 / 31 / 1988", "score": 62 },
            { "learnerId": 4, "lastName": "Clooney", "firstName": "George", "dateCompleted": "06 / 10 / 2008", "score": 25 },
            { "learnerId": 316, "lastName": "Affleck", "firstName": "Ben", "dateCompleted": "11 / 05 / 1994", "score": 43 },
            { "learnerId": 317, "lastName": "Norton", "firstName": "Ed", "dateCompleted": "08 / 10 / 2011", "score": 45 },
            { "learnerId": 318, "lastName": "Hardy", "firstName": "Tom", "dateCompleted": "07 / 13 / 2002", "score": 76 },
            { "learnerId": 319, "lastName": "De Niro", "firstName": "Robert", "dateCompleted": "11 / 24 / 2004", "score": 78 },
            { "learnerId": 320, "lastName": "Bale", "firstName": "Christian", "dateCompleted": "11 / 25 / 2014", "score": 68 }
        ];
		
		var ds = [
            { "defaultDate": "11/11/2011", "defaultScore": "80" }
        ];

    $("#grid").igGrid({
        primaryKey: "learnerId",
        height: 200,
        columns: [
                { headerText: "LearnerId", key: "learnerId", dataType: "number", template: "${learnerId}", width: 60, hidden: true },
                { headerText: "Last Name", key: "lastName", dataType: "string", template: "${lastName}", width: 150 },
                { headerText: "First Name", key: "firstName", dataType: "string", template: "${firstName}", width: 150 },
                { headerText: "Date Completed", key: "dateCompleted", dataType: "date", template: "${dateCompleted}", width: 120 },
                { headerText: "Score", key: "score", dataType: "string", template: "${score}", width: 80 },
            ],
        autoGenerateColumns: false,
        dataSource: data,
        dataRendered: function (evt, ui) {
            ui.owner.element.find("tr td:nth-child(3)").css("text-align", "center");
            ui.owner.element.find("tr td:nth-child(4)").css("text-align", "center");
        },
        features: [
            {
                name: "Updating",
                enableAddRow: false,
                enableDeleteRow: false,
                editMode: "row",
                responseDataKey: "results",
                columnSettings: [
                    { columnKey: "lastName", readOnly: true },
                    { columnKey: "firstName", readOnly: true },
                    { columnKey: "dateCompleted", editorType: "datepicker", required: true },
                    { columnKey: "score", editorType: "numeric", required: true, dataMode: "int",
                        editorOptions: {
                            button: "spin",
                            minValue: 0,
                            maxValue: 100
                        }
                    }
                ],
                editRowStarted: function (evt, ui) {
                    $(".ui-iggrid-buttoncontainer").css("margin-left", "100px")
                    rowIndex = ui.rowID;
                    defaultDate = GetDefaultDate();
                    defaultScore = GetDefaultScore();
                    var rowValues = { "dateCompleted": defaultDate, "score": defaultScore };
                    // inserts DOm element via .append method
                    if ($("#btnApplyDefaults").length == 0) {
                        $(".ui-iggrid-buttoncontainer").append("<span id='btnApplyDefaults'></span>");
                        $("#btnApplyDefaults").addClass("ui-iggrid-button ui-state-default ui-corner-all");
                        $("#btnApplyDefaults").append("<span style='display: inline-block; padding: 3px 10px 5px 10px;'>Apply Defaults</span>")
                    }
                    // updates the row with predefined values that are holded in the rowValues object
                    $("#btnApplyDefaults").on("click", function () {
                        $("#grid").igGridUpdating("updateRow", rowIndex, rowValues);
                    });
                },
				editRowStarting: function(evt, ui){
					//debugger;
					var rowId = ui.rowID;
					data = $("#grid").data('igGrid').dataSource;
					data.setCellValue(rowId, "dateCompleted", ds[0].defaultDate, true);
					data.setCellValue(rowId, "score", ds[0].defaultScore, true);
				},
				editRowEnded: function(evt, ui){
					$("#grid").igGrid('dataBind');
				}
            }]
    });

    InitIgUI();

});


// ----------------------------------------------------

//function OnSaveChangesSuccess(Result) 
//{
//	loadingIndicator.hide();
//}

//function OnSaveChangesError(ex)
//{
//	loadingIndicator.hide();
//	DisplayError(ex.responseText);
//}

// ----------------------------------------------------

//function ManualScoringInit()
//{
//    DetectBrowser();

//	PostbackInfo.CustomGetPostbackInfo = false;
//    GetPostbackInfo(OnManualScoringPostbackInfo);
//}

// ----------------------------------------------------

function InitDefaultsGrid() {

    var ds = [
            { "pk": 1, "defaultDate": "11/11/2011", "defaultScore": "80" }
        ];

    $("#unscoredDefaultsGrid").igGrid({
        primaryKey: "pk",
        columns: [
                { headerText: "pk", key: "pk", dataType: "number", width: 0, hidden: true },
                { headerText: "Default Completion Date", key: "defaultDate", dataType: "date", width: 120 },
                { headerText: "Default Score", key: "defaultScore", dataType: "number", width: 80 }
        ],

        dataSource: ds,
        dataRendered: function (evt, ui) {
            ui.owner.element.find("tr td:nth-child(1)").css("text-align", "center");
            ui.owner.element.find("tr td:nth-child(2)").css("text-align", "center");
        },
        features: [
            {
                name: "Updating",
                enableAddRow: false,
                editMode: "row",
                enableDeleteRow: false,
                columnSettings: [
                    { columnKey: "defaultDate", editorType: "datepicker", required: true },
                    { columnKey: "defaultScore", editorType: "numeric", required: true, dataMode: "int",
                        editorOptions: {
                            button: "spin",
                            minValue: 0,
                            maxValue: 100
                        }
                    },
                ]
            }]
    });
}


//function OnManualScoringPostbackInfo(xmlText)
//{
//	OnPostbackInfo(xmlText);

//	ExecPostbackForId("GetData");
//}

// ----------------------------------------------------

function InitIgUI() {

	grid = $("#grid");
	//loadingIndicator = new GridModalLoadingIndicator(grid);

	$("#saveChanges").igButton({ labelText: $("#saveChanges").val(), disabled: true });
	$("#saveChanges").on('igbuttonclick', OnSaveChangesClick);

	$("#undo").igButton({ labelText: $("#undo").val(), disabled: true });
	$("#undo").on('igbuttonclick', OnUndoClick);

	$("#redo").igButton({ labelText: $("#redo").val(), disabled: true });
	$("#redo").on('igbuttonclick', OnRedoClick);

	$("#btnDefaultsAll").igButton({ labelText: $("#btnDefaultsAll").val(), disabled: false });

	grid.on("iggridupdatingeditrowended", function (e, args) {
	    if (args.update) {
	        $("#undo").igButton("option", "disabled", false);
	        $("#saveChanges").igButton("option", "disabled", false);
	    }
	});

	$("#btnDefaultsAll").on("igbuttonclick", function () {

	    var rowsLength = $("#grid").igGrid("allRows").length;

	    for (var i = 0; i < rowsLength; i++) {
	        var row = $("#grid").igGrid("rowAt", i); // loops through all 
	        var rowID = parseFloat($(row).attr("data-id"));          // the rows and get their rowID
	        $("#grid").igGridUpdating("setCellValue", rowID, "dateCompleted", GetDefaultDate());   // sets null value for every cell
	        $("#grid").igGridUpdating("setCellValue", rowID, "score", GetDefaultScore());  // in the last 2 columns
	    }

	    $("#undo").igButton("option", "disabled", false);
	    $("#saveChanges").igButton("option", "disabled", false);

	});

	InitDefaultsGrid();
}


function GetDefaultDate() {
    var defaultDate = $('#unscoredDefaultsGrid').find('tr:first').find('td:first').text();
    return defaultDate;
}

function GetDefaultScore() {
    defaultScore = $('#unscoredDefaultsGrid').find('tr:first').find('td:nth-child(2)').text();
    return defaultScore;
}
// ----------------------------------------------------

function OnSaveChangesClick(e) {
    grid.igGrid("saveChanges", OnSaveChangesSuccess, OnSaveChangesError);

    loadingIndicator.show();
    $("#undo").igButton("disable");
    $(this).igButton("disable");
    return false;
}

// ----------------------------------------------------

// ----------------------------------------------------

function OnRedoClick(e) {
    $.each(updates, function (index, transaction) {
        switch (transaction.type) {
            case "row":
                grid.igGridUpdating('updateRow', transaction.rowId, transaction.row, null, false);
                break;
        }

    });
    $(this).igButton("disable");
    $("#undo").igButton("option", "disabled", false);
    $("#saveChanges").igButton("option", "disabled", false);
}

// ----------------------------------------------------

function OnUndoClick(e) {
    updates = $.extend({}, grid.data('igGrid').pendingTransactions());
    $.each(updates, function (index, transaction) {
        grid.igGrid("rollback", transaction.rowId, true);
    });

    $("#redo").igButton("option", "disabled", false);
    $("#undo").igButton("disable");
    $("#saveChanges").igButton("disable");

    return false;
}

